//
//  Rs[^OtBbNX_U
//  􉽌`f[^iObj`j̓ǂݍ݁`̃TvvO
//

#ifndef  _OBJ_H_
#define  _OBJ_H_


// xNgf[^
struct  Vector
{
	float   x, y, z;
};


// J[f[^
struct  Color
{
	float  r, g, b;
};


// 􉽌`f[^̗i{vOł͎gpȂj
struct  SampleGeometry
{
	int       num_vertices;  // _
	Vector *  vertices;      // _Wz [num_vertices]
	Vector *  normals;       // @xNgz [num_vertices]
	Color *   colors;        // J[z [num_vertices]

	int       num_triangles; // Opʐ
	int *     triangles;     // Opʂ̒_ԍz [num_triangles*3]
};


// }eAf[^iMtl`pj
struct  Mtl
{
	char *     name;          // }eA

	Color      kd;            // gUˌiƂ肠gUˌ glColor3f() Ŏgpj

	char *     texture_name;  // eNX`摜̃t@C
};


// 􉽌`f[^iObj`pj
struct  Obj
{
	int        num_vertices;  // _
	Vector *   vertices;      // _Wz [num_vertices]

	int        num_normals;
	Vector *   normals;       // @xNgz [num_normals]

	int        num_tex_coords;
	Vector *   tex_coords;    // eNX`Wz [num_tex_coords]

	int        num_triangles; // Opʐ
	int *      tri_v_no;      // Opʂ̊e_̒_Wԍz [num_triangles*3]
	int *      tri_vn_no;     // Opʂ̊e_̖@xNgԍz [num_triangles*3]
	int *      tri_vt_no;     // Opʂ̊e_̃eNX`Wԍz [num_triangles*3]
	Mtl **     tri_material;  // Opʂ̑f [num_triangles]

	int        num_materials; // }eA
	Mtl **     materials;     // }eA̔z [num_materials]
};



// Objt@C̓ǂݍ
Obj *  LoadObj( const char * filename );

// Mtlt@C̓ǂݍ
void  LoadMtl( const char * filename, Obj * obj );

// IuWFNg̃XP[OiXP[O̒S̍Ԃj
float  ScaleObj( Obj * obj, float max_size );

// Obj`f[^̕`
void  RenderObj( Obj * obj );


#endif // _OBJ_H_
